package dj15.server.command;

/**
 * GetFileInfoCommand
 * @author Hiromasa Ogawa
 * @version 1.0
 */
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import dj15.server.*;
import dj15.server.util.*;

public class GetFileInfoCommand implements Command{

    public GetFileInfoCommand() {
        super();
    }

    public void execute( RequestHelper requestHelper)
                        throws ServletException,IOException {

        String fnam = requestHelper.getRequest().getParameter("name");
        if(fnam == null) {
            requestHelper.retBadRequest("name",fnam);
        }
        File file = new File(requestHelper.getContext().getRealPath(fnam));
        if(!file.exists()){
            requestHelper.retBadRequest("name",fnam);
        }

        String per = requestHelper.getRequest().getParameter("per");
        if(per == null) {
            requestHelper.retBadRequest("per",per);
        }
        int iper = 0;
        try {
            iper = Integer.parseInt(per);
        } catch (NumberFormatException nfe) {}
        if( iper < 1024) {
            requestHelper.retBadRequest("per",per);
        }

        long size = file.length();
        int arr_len = (int)size/iper + (size%iper!=0?1:0);

        /** create response byte[] */
        requestHelper.getResponse().setContentType("application/octet-stream");
        ByteArrayOutputStream bao = new ByteArrayOutputStream();
        DataOutputStream dos = new DataOutputStream(bao);
        dos.writeInt(arr_len);
        int ofs = 0;
        for(int i=0; i<arr_len; i++) {
            dos.writeInt(ofs);
            if (i==arr_len-1 && size%iper!=0) {
                dos.writeInt((int)size%iper);
            } else {
                dos.writeInt(iper);
            }
            ofs += iper;
        }
        //bao.write(new String("file:" +file.getAbsolutePath()+ " exist:"+file.exists()).getBytes());

        DataOutputStream out = new DataOutputStream(
                                    requestHelper.getResponse().getOutputStream());
        out.write(bao.toByteArray());
        out.close();
        dos.close();
        requestHelper.getResponse().setContentLength(bao.size());
    }
}