package dj15.server.logger;

/**
 * @author user
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class Level {
	/** DEBUG Level **/
	private static final int INT_DEBUG = 10000;
	public static final Level DEBUG = new Level (INT_DEBUG, "DEBUG");
	/** INFO Level **/
	private static final int INT_INFO  = 20000;
	public static final Level INFO  = new Level (INT_INFO,  "INFO");
	/** ERROR Level **/
	private static final int INT_ERROR = 50000;
	public static final Level ERROR = new Level (INT_ERROR, "ERROR");
	
	private int currentLevel;
	private String currentName;
	/**
	 * constructor
	 * @param level	Level(int)
	 * @param levelstr	Level(String)
	 */
	private Level(int level, String levelstr){
		this.currentLevel = level;
		this.currentName  = levelstr;
	}
	
	/**
	 * The method which investigates whether logging is possible
	 * @param level		Logging Level
	 * @return boolean
	 */
	public boolean isLoggingLevel(Level level){
		return this.toInt() > level.toInt() ? false : true;
	}
	
	/**
	 * The logging level corresponding to given character sequence expression is returned.
	 * @param name
	 * @return Level
	 */
	public static Level getIgnoreEqualLoggingLevel(String name){
		if(name == null){
			return Level.getDefault();	
		}
		name.trim();
		if(name.equalsIgnoreCase(Level.DEBUG.toString())){
			return Level.DEBUG;
		}else if(name.equalsIgnoreCase(Level.INFO.toString())){
			return Level.INFO;
		}else if(name.equalsIgnoreCase(Level.ERROR.toString())){
			return Level.ERROR;	
		}
		
		return Level.getDefault();
	}
	
	
	/**
	 * get default logging level
	 * @return Level
	 */
	public static Level getDefault(){
		return Level.DEBUG;	
	}
	
	
	/**
	 * A logging level is changed into character sequence expression.
	 * @return String
	 * @see java.lang.Object#toString()
	 */
	public String toString(){
		return this.currentName;	
	}
	
	/**
	 * A logging level is changed into numerical sequence expression.
	 * @return int
	 */
	public int toInt(){
		return this.currentLevel;	
	}
	

}
